Index: trunk/src/lib/BuildLibs.am
===================================================================
--- trunk/src/lib/BuildLibs.am	(revision 9682)
+++ trunk/src/lib/BuildLibs.am	(revision 9869)
@@ -1,16 +1,9 @@
 
 libORXlibs_a_LIBRARIES_ = \
-                $(LIB_PREFIX)/util/libORXlibutil.a \
-                $(LIB_PREFIX)/shell/libORXshell.a \
                 $(LIB_PREFIX)/event/libORXevent.a \
                 $(LIB_PREFIX)/gui/qt/libORXqtgui.a \
                 $(LIB_PREFIX)/gui/gl/libORXglgui.a \
                 $(LIB_PREFIX)/gui/libORXbasegui.a \
-                $(LIB_PREFIX)/script_engine/libORXscript.a \
-                $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
                 $(LIB_PREFIX)/graphics/libORXgraphics.a \
-                $(LIB_PREFIX)/graphics/importer/libtc.a \
-                $(LIB_PREFIX)/sound/libORXsound.a \
-                $(LIB_PREFIX)/particles/libORXparticles.a \
                 $(LIB_PREFIX)/collision_detection/libORXcd.a \
                 $(LIB_PREFIX)/collision_reaction/libORXcr.a \
@@ -23,7 +16,13 @@
                 $(LIB_PREFIX)/physics/libORXphysics.a \
                 $(LIB_PREFIX)/gui/gl/libORXglgui.a \
+                \
+                $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
+                $(LIB_PREFIX)/graphics/importer/libtc.a \
+                $(LIB_PREFIX)/sound/libORXsound.a \
                 $(LIB_PREFIX)/shell/libORXshell.a \
-                $(LIB_PREFIX)/math/libORXmath.a \
+                $(LIB_PREFIX)/script_engine/libORXscript.a \
+                $(LIB_PREFIX)/util/libORXexecutor.a \
                 $(LIB_PREFIX)/util/libORXlibutil.a \
                 $(LIB_PREFIX)/lang/libORXlang.a \
-                $(LIB_PREFIX)/libORXlibs.a
+                $(LIB_PREFIX)/libORXlibs.a \
+                $(LIB_PREFIX)/math/libORXmath.a
Index: trunk/src/lib/Makefile.am
===================================================================
--- trunk/src/lib/Makefile.am	(revision 9682)
+++ trunk/src/lib/Makefile.am	(revision 9869)
@@ -25,10 +25,9 @@
 	event \
 	physics \
-	particles \
 	collision_detection \
 	collision_reaction \
 	gui \
 	network \
+	shell \
 	parser \
-	shell \
 	script_engine
Index: trunk/src/lib/collision_detection/aabb.cc
===================================================================
--- trunk/src/lib/collision_detection/aabb.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/aabb.cc	(revision 9869)
@@ -21,5 +21,5 @@
 
 
-
+ObjectListDefinition(AABB);
 /**
  *  standard constructor
@@ -27,5 +27,5 @@
 AABB::AABB ()
 {
-   this->setClassID(CL_OBB, "AABB");
+  this->registerObject(this, AABB::_objectList);
    this->halfLength[0] = this->halfLength[1] = this->halfLength[2] = 0.0f;
    this->bCollided = false;
Index: trunk/src/lib/collision_detection/aabb.h
===================================================================
--- trunk/src/lib/collision_detection/aabb.h	(revision 9682)
+++ trunk/src/lib/collision_detection/aabb.h	(revision 9869)
@@ -11,8 +11,7 @@
 #include "bounding_volume.h"
 
-template<class T> class tList;
-
 //! A class representing an extended bounding volume tree: an obb tree
 class AABB : public BoundingVolume {
+  ObjectListDeclaration(AABB);
 
  public:
Index: trunk/src/lib/collision_detection/aabb_tree_node.cc
===================================================================
--- trunk/src/lib/collision_detection/aabb_tree_node.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/aabb_tree_node.cc	(revision 9869)
@@ -32,12 +32,7 @@
 #include "debug.h"
 
-
-
-
-
-
 GLUquadricObj* AABBTreeNode_sphereObj = NULL;
 
-
+ObjectListDefinition(AABBTreeNode);
 /**
  *  standard constructor
@@ -48,5 +43,5 @@
     : BVTreeNode()
 {
-  this->setClassID(CL_OBB_TREE_NODE, "AABBTreeNode");
+  this->registerObject(this, AABBTreeNode::_objectList);
 
   this->obbTree = &tree;
Index: trunk/src/lib/collision_detection/aabb_tree_node.h
===================================================================
--- trunk/src/lib/collision_detection/aabb_tree_node.h	(revision 9682)
+++ trunk/src/lib/collision_detection/aabb_tree_node.h	(revision 9869)
@@ -21,4 +21,5 @@
 class AABBTreeNode : public BVTreeNode
 {
+  ObjectListDeclaration(AABBTreeNode);
 
 
Index: trunk/src/lib/collision_detection/bounding_sphere.cc
===================================================================
--- trunk/src/lib/collision_detection/bounding_sphere.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/bounding_sphere.cc	(revision 9869)
@@ -20,5 +20,5 @@
 
 
-
+ObjectListDefinition(BoundingSphere);
 /**
  *  standard constructor
@@ -26,5 +26,5 @@
 BoundingSphere::BoundingSphere ()
 {
-   this->setClassID(CL_BOUNDING_SPHERE, "BoundingSphere");
+  this->registerObject(this, BoundingSphere::_objectList);
 }
 
Index: trunk/src/lib/collision_detection/bounding_sphere.h
===================================================================
--- trunk/src/lib/collision_detection/bounding_sphere.h	(revision 9682)
+++ trunk/src/lib/collision_detection/bounding_sphere.h	(revision 9869)
@@ -1,3 +1,3 @@
-/*! 
+/*!
  * @file bounding_sphere.h
   *  Definition of a bounding sphere
@@ -14,4 +14,5 @@
 //! A class representing an extended bounding volume tree: an sphere
 class BoundingSphere : public BoundingVolume {
+  ObjectListDeclaration(BoundingSphere);
 
  public:
Index: trunk/src/lib/collision_detection/bounding_volume.cc
===================================================================
--- trunk/src/lib/collision_detection/bounding_volume.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/bounding_volume.cc	(revision 9869)
@@ -20,5 +20,5 @@
 
 
-
+ObjectListDefinition(BoundingVolume);
 /**
  *  standard constructor
@@ -26,5 +26,5 @@
 BoundingVolume::BoundingVolume ()
 {
-  this->setClassID(CL_BOUNDING_VOLUME, "BoundingVolume");
+  this->registerObject(this, BoundingVolume::_objectList);
   this->modelInf = NULL;
   this->triangleIndexes = NULL;
Index: trunk/src/lib/collision_detection/bounding_volume.h
===================================================================
--- trunk/src/lib/collision_detection/bounding_volume.h	(revision 9682)
+++ trunk/src/lib/collision_detection/bounding_volume.h	(revision 9869)
@@ -17,4 +17,5 @@
 //! An abstract class representing a bounding volume
 class BoundingVolume : public BaseObject {
+  ObjectListDeclaration(BoundingVolume);
 
   public:
Index: trunk/src/lib/collision_detection/bv_tree.cc
===================================================================
--- trunk/src/lib/collision_detection/bv_tree.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/bv_tree.cc	(revision 9869)
@@ -21,5 +21,5 @@
 
 
-
+ObjectListDefinition(BVTree);
 /**
  *  standard constructor
@@ -27,5 +27,5 @@
 BVTree::BVTree ()
 {
-   this->setClassID(CL_BV_TREE, "BVTree");
+  this->registerObject(this, BVTree::_objectList);
 
 }
Index: trunk/src/lib/collision_detection/bv_tree.h
===================================================================
--- trunk/src/lib/collision_detection/bv_tree.h	(revision 9682)
+++ trunk/src/lib/collision_detection/bv_tree.h	(revision 9869)
@@ -36,4 +36,5 @@
 class BVTree : public BaseObject
 {
+  ObjectListDeclaration(BVTree);
 
   public:
Index: trunk/src/lib/collision_detection/bv_tree_node.cc
===================================================================
--- trunk/src/lib/collision_detection/bv_tree_node.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/bv_tree_node.cc	(revision 9869)
@@ -20,5 +20,5 @@
 
 
-
+ObjectListDefinition(BVTreeNode);
 /**
  *  standard constructor
@@ -26,5 +26,5 @@
 BVTreeNode::BVTreeNode ()
 {
-   this->setClassID(CL_BV_TREE_NODE, "BVTreeNode");
+  this->registerObject(this, BVTreeNode::_objectList);
 
 }
Index: trunk/src/lib/collision_detection/bv_tree_node.h
===================================================================
--- trunk/src/lib/collision_detection/bv_tree_node.h	(revision 9682)
+++ trunk/src/lib/collision_detection/bv_tree_node.h	(revision 9869)
@@ -24,4 +24,5 @@
 //! A class that represents a bounding volume tree
 class BVTreeNode : public BaseObject {
+  ObjectListDeclaration(BVTreeNode);
 
 
Index: trunk/src/lib/collision_detection/cd_engine.cc
===================================================================
--- trunk/src/lib/collision_detection/cd_engine.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/cd_engine.cc	(revision 9869)
@@ -20,6 +20,4 @@
 #include "debug.h"
 
-#include "class_list.h"
-
 #include "model.h"
 #include "world_entity.h"
@@ -36,11 +34,11 @@
 
 
-
+ObjectListDefinition(CDEngine);
 /**
- *  standard constructor
+ * @brief standard constructor
  */
 CDEngine::CDEngine ()
 {
-  this->setClassID(CL_CD_ENGINE, "CDEngine");
+  this->registerObject(this, CDEngine::_objectList);
 
   this->bAbordOnFirstCollision = false;
@@ -103,13 +101,9 @@
 void CDEngine::checkCollisionGround(std::list<WorldEntity*>& list1)
 {
-
-  std::list<BaseObject*>::const_iterator bspIterator;
   std::list<WorldEntity*>::iterator entityIterator;
-  const std::list<BaseObject*>* bspList = ClassList::getList(CL_BSP_ENTITY);
-  if( bspList == NULL)
-    return;
-
   // for all bsp managers check all entities
-  for( bspIterator = bspList->begin(); bspIterator != bspList->end(); bspIterator++) {
+  for( ObjectList<BspEntity>::const_iterator bspIterator = BspEntity::objectList().begin();
+       bspIterator != BspEntity::objectList().end();
+       bspIterator++) {
       for(entityIterator = list1.begin(); entityIterator != list1.end(); entityIterator++)
       {
Index: trunk/src/lib/collision_detection/cd_engine.h
===================================================================
--- trunk/src/lib/collision_detection/cd_engine.h	(revision 9682)
+++ trunk/src/lib/collision_detection/cd_engine.h	(revision 9869)
@@ -36,4 +36,5 @@
 //! The class representing the collision detection system of orxonox
 class CDEngine : public BaseObject {
+  ObjectListDeclaration(CDEngine);
 
   friend class WorldEntity;
Index: trunk/src/lib/collision_detection/obb.cc
===================================================================
--- trunk/src/lib/collision_detection/obb.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/obb.cc	(revision 9869)
@@ -21,5 +21,5 @@
 
 
-
+ObjectListDefinition(OBB);
 /**
  *  standard constructor
@@ -27,5 +27,5 @@
 OBB::OBB ()
 {
-   this->setClassID(CL_OBB, "OBB");
+  this->registerObject(this, OBB::_objectList);
    this->halfLength[0] = this->halfLength[1] = this->halfLength[2] = 0.0f;
    this->bCollided = false;
Index: trunk/src/lib/collision_detection/obb.h
===================================================================
--- trunk/src/lib/collision_detection/obb.h	(revision 9682)
+++ trunk/src/lib/collision_detection/obb.h	(revision 9869)
@@ -15,4 +15,5 @@
 //! A class representing an extended bounding volume tree: an obb tree
 class OBB : public BoundingVolume {
+  ObjectListDeclaration(OBB);
 
  public:
Index: trunk/src/lib/collision_detection/obb_tree.cc
===================================================================
--- trunk/src/lib/collision_detection/obb_tree.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/obb_tree.cc	(revision 9869)
@@ -27,5 +27,5 @@
 
 
-
+ObjectListDefinition(OBBTree);
 /**
  *  standard constructor
@@ -51,5 +51,5 @@
 void OBBTree::init()
 {
-  this->setClassID(CL_OBB_TREE, "OBBTree");
+  this->registerObject(this, OBBTree::_objectList);
   this->rootNode = NULL;
   this->id = 0;
Index: trunk/src/lib/collision_detection/obb_tree.h
===================================================================
--- trunk/src/lib/collision_detection/obb_tree.h	(revision 9682)
+++ trunk/src/lib/collision_detection/obb_tree.h	(revision 9869)
@@ -20,4 +20,5 @@
 class OBBTree : public BVTree
 {
+  ObjectListDeclaration(OBBTree);
 
   public:
Index: trunk/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 9682)
+++ trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 9869)
@@ -38,5 +38,5 @@
 GLUquadricObj* OBBTreeNode_sphereObj = NULL;
 
-
+ObjectListDefinition(OBBTreeNode);
 /**
  *  standard constructor
@@ -47,5 +47,5 @@
     : BVTreeNode()
 {
-  this->setClassID(CL_OBB_TREE_NODE, "OBBTreeNode");
+  this->registerObject(this, OBBTreeNode::_objectList);
 
   this->obbTree = &tree;
@@ -284,5 +284,5 @@
 
 /**
- *  calculate the eigenvectors for the object oriented box
+ * @brief calculate the eigenvectors for the object oriented box
  * @param box: reference to the box
  * @param modelInf: the model info structure of the model
@@ -361,5 +361,5 @@
 
 /**
- *  this separates an ob-box in the middle
+ * @brief this separates an ob-box in the middle
  * @param box: the box to separate
  *
Index: trunk/src/lib/collision_detection/obb_tree_node.h
===================================================================
--- trunk/src/lib/collision_detection/obb_tree_node.h	(revision 9682)
+++ trunk/src/lib/collision_detection/obb_tree_node.h	(revision 9869)
@@ -17,10 +17,8 @@
 class PNode;
 
-
 //! A class that represents a bounding volume tree
 class OBBTreeNode : public BVTreeNode
 {
-
-
+  ObjectListDeclaration(OBBTreeNode);
   public:
     OBBTreeNode(const OBBTree& tree, OBBTreeNode* prev, int depth);
Index: trunk/src/lib/collision_reaction/collision_handle.cc
===================================================================
--- trunk/src/lib/collision_reaction/collision_handle.cc	(revision 9682)
+++ trunk/src/lib/collision_reaction/collision_handle.cc	(revision 9869)
@@ -30,5 +30,5 @@
 
 
-
+ObjectListDefinition(CollisionHandle);
 
 /**
@@ -38,5 +38,5 @@
 CollisionHandle::CollisionHandle (WorldEntity* owner, CREngine::CRType type)
 {
-  this->setClassID(CL_COLLISION_HANDLE, "CollisionHandle");
+  this->registerObject(this, CollisionHandle::_objectList);
 
   this->owner = owner;
@@ -94,16 +94,16 @@
  *  @param classID the classid to look for
  */
-void CollisionHandle::addTarget(long target)
+void CollisionHandle::addTarget(const ClassID& target)
 {
   // make sure there is no dublicate
-  std::vector<long>::iterator it = this->targetList.begin();
+  std::vector<ClassID>::iterator it = this->targetList.begin();
   for( ; it < this->targetList.end(); it++)
     if( (*it) == target)
       return;
 
+
   // add element
-   PRINTF(5)("addTarget: %i \n", target);
-
-   this->targetList.push_back(target);
+  this->targetList.push_back(target);
+   PRINTF(5)("addTarget: %i \n", target.id());
 }
 
@@ -227,5 +227,5 @@
 bool CollisionHandle::filterCollisionEvent(CollisionEvent* collisionEvent)
 {
-  std::vector<long>::iterator it = this->targetList.begin();
+  std::vector<ClassID>::iterator it = this->targetList.begin();
   for(; it < this->targetList.end(); it++)
   {
@@ -253,13 +253,13 @@
 
     if( collisionEvent->getEntityA() == this->owner) {
-      if( collisionEvent->getEntityB()->isA((ClassID)(*it))) {
+      if( collisionEvent->getEntityB()->isA((*it))) {
         PRINTF(5)("I am: %s colliding with: %s is a %i filter ok\n", owner->getClassCName(),
-                  collisionEvent->getEntityB()->getClassCName(), *it);
+	collisionEvent->getEntityB()->getClassCName(), (*it).id());
         return true; }
     }
     else {
-      if( collisionEvent->getEntityA()->isA((ClassID)(*it))) {
+      if( collisionEvent->getEntityA()->isA((*it))) {
         PRINTF(5)("I am: %s colliding with: %s is a %i filter ok\n", owner->getClassCName(),
-                  collisionEvent->getEntityA()->getClassCName(), *it);
+	collisionEvent->getEntityA()->getClassCName(), (*it).id());
       return true; }
     }
@@ -276,5 +276,5 @@
 bool CollisionHandle::filterCollision(Collision* collision)
 {
-  std::vector<long>::iterator it = this->targetList.begin();
+  std::vector<ClassID>::iterator it = this->targetList.begin();
   for(; it < this->targetList.end(); it++)
   {
@@ -302,8 +302,8 @@
 
     if( collision->getEntityA() == this->owner) {
-      if( collision->getEntityA()->isA((ClassID)(*it)))
+      if( collision->getEntityA()->isA(*it))
         return true; }
       else {
-        if( collision->getEntityB()->isA((ClassID)(*it)))
+        if( collision->getEntityB()->isA(*it))
           return true; }
   }
Index: trunk/src/lib/collision_reaction/collision_handle.h
===================================================================
--- trunk/src/lib/collision_reaction/collision_handle.h	(revision 9682)
+++ trunk/src/lib/collision_reaction/collision_handle.h	(revision 9869)
@@ -23,5 +23,5 @@
 class CollisionHandle : public BaseObject
 {
-
+  ObjectListDeclaration(CollisionHandle);
   public:
     CollisionHandle(WorldEntity* owner, CREngine::CRType type);
@@ -30,5 +30,5 @@
     void reset();
 
-    void addTarget(long target);
+    void addTarget(const ClassID& target);
     Collision* registerCollision(WorldEntity* entityA, WorldEntity* entityB);
     void registerSharedCollision(Collision* collision);
@@ -64,5 +64,6 @@
 
     std::vector<Collision*>       collisionList;           //!< a list full of collisions
-    std::vector<long>             targetList;              //!< a list of target classes for filtering
+    /// TODO Take a std::set here!
+    std::vector<ClassID>          targetList;              //!< a list of target classes for filtering @TODO TAKE SET INSTEAD OF VECTOR HERE
 
     CollisionReaction*            collisionReaction;       //!< reference to the collision reaction object
Index: trunk/src/lib/collision_reaction/collision_reaction.cc
===================================================================
--- trunk/src/lib/collision_reaction/collision_reaction.cc	(revision 9682)
+++ trunk/src/lib/collision_reaction/collision_reaction.cc	(revision 9869)
@@ -20,5 +20,5 @@
 
 
-
+ObjectListDefinition(CollisionReaction);
 
 /**
@@ -28,5 +28,5 @@
   : BaseObject()
 {
-  this->setClassID(CL_COLLISION_REACTION, "CollisionReaction");
+  this->registerObject(this, CollisionReaction::_objectList);
 }
 
Index: trunk/src/lib/collision_reaction/collision_reaction.h
===================================================================
--- trunk/src/lib/collision_reaction/collision_reaction.h	(revision 9682)
+++ trunk/src/lib/collision_reaction/collision_reaction.h	(revision 9869)
@@ -18,5 +18,5 @@
 class CollisionReaction : public BaseObject
 {
-
+  ObjectListDeclaration(CollisionReaction);
   public:
     CollisionReaction();
Index: trunk/src/lib/collision_reaction/cr_engine.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_engine.cc	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_engine.cc	(revision 9869)
@@ -29,5 +29,5 @@
 
 
-
+ObjectListDefinition(CREngine);
 /**
  * standard constructor
@@ -36,5 +36,5 @@
   : BaseObject()
 {
-   this->setClassID(CL_CR_ENGINE, "CREngine");
+  this->registerObject(this, CREngine::_objectList);
    this->setName("CREngine");
 
Index: trunk/src/lib/collision_reaction/cr_engine.h
===================================================================
--- trunk/src/lib/collision_reaction/cr_engine.h	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_engine.h	(revision 9869)
@@ -25,4 +25,5 @@
 class CREngine : public BaseObject
 {
+  ObjectListDeclaration(CREngine);
 
   public:
Index: trunk/src/lib/collision_reaction/cr_object_damage.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_object_damage.cc	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_object_damage.cc	(revision 9869)
@@ -28,5 +28,5 @@
 
 
-
+ObjectListDefinition(CRObjectDamage);
 /**
  *  standard constructor
@@ -35,6 +35,5 @@
   : CollisionReaction()
 {
-  this->setClassID(CL_CR_OBJECT_DAMAGE, "CRObjectDamage");
-
+  this->registerObject(this, CRObjectDamage::_objectList);
 }
 
Index: trunk/src/lib/collision_reaction/cr_object_damage.h
===================================================================
--- trunk/src/lib/collision_reaction/cr_object_damage.h	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_object_damage.h	(revision 9869)
@@ -15,4 +15,5 @@
 class CRObjectDamage : public CollisionReaction
 {
+  ObjectListDeclaration(CRObjectDamage);
   public:
     CRObjectDamage();
Index: trunk/src/lib/collision_reaction/cr_physics_full_walk.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_physics_full_walk.cc	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_physics_full_walk.cc	(revision 9869)
@@ -35,5 +35,5 @@
 
 
-
+ObjectListDefinition(CRPhysicsFullWalk);
 /**
  *  standard constructor
@@ -42,5 +42,5 @@
     : CollisionReaction()
 {
-  this->setClassID(CL_CR_PHYSICS_FULL_WALK, "CRPhysicsFullWalk");
+  this->registerObject(this, CRPhysicsFullWalk::_objectList);
 }
 
Index: trunk/src/lib/collision_reaction/cr_physics_full_walk.h
===================================================================
--- trunk/src/lib/collision_reaction/cr_physics_full_walk.h	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_physics_full_walk.h	(revision 9869)
@@ -15,4 +15,5 @@
 class CRPhysicsFullWalk : public CollisionReaction
 {
+  ObjectListDeclaration(CRPhysicsFullWalk);
   public:
     CRPhysicsFullWalk();
Index: trunk/src/lib/collision_reaction/cr_physics_ground_walk.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 9869)
@@ -35,5 +35,5 @@
 
 
-
+ObjectListDefinition(CRPhysicsGroundWalk);
 /**
  *  standard constructor
@@ -42,5 +42,5 @@
     : CollisionReaction()
 {
-  this->setClassID(CL_CR_PHYSICS_GROUND_WALK, "CRPhysicsGroundWalk");
+  this->registerObject(this, CRPhysicsGroundWalk::_objectList);
 }
 
Index: trunk/src/lib/collision_reaction/cr_physics_ground_walk.h
===================================================================
--- trunk/src/lib/collision_reaction/cr_physics_ground_walk.h	(revision 9682)
+++ trunk/src/lib/collision_reaction/cr_physics_ground_walk.h	(revision 9869)
@@ -15,4 +15,5 @@
 class CRPhysicsGroundWalk : public CollisionReaction
 {
+  ObjectListDeclaration(CRPhysicsGroundWalk);
   public:
     CRPhysicsGroundWalk();
Index: trunk/src/lib/coord/p_node.cc
===================================================================
--- trunk/src/lib/coord/p_node.cc	(revision 9682)
+++ trunk/src/lib/coord/p_node.cc	(revision 9869)
@@ -19,5 +19,4 @@
 
 #include "util/loading/load_param.h"
-#include "class_list.h"
 
 #include "netdefs.h"
@@ -30,4 +29,6 @@
 #include "color.h"
 
+
+ObjectListDefinition(PNode);
 /**
  * @brief standard constructor
@@ -38,5 +39,5 @@
   : BaseObject(), Synchronizeable()
 {
-  this->setClassID(CL_PARENT_NODE, "PNode");
+  this->registerObject(this, PNode::_objectList);
 
   this->bRelCoorChanged = true;
@@ -79,19 +80,25 @@
   PRINTF(4)("delete %s::%s\n", this->getClassCName(), this->getCName());
   // remove the Node, delete it's children (if required).
-  std::list<PNode*>::iterator deleteNode;
-  unsigned int size;
+  PNode* last = NULL;
+  //this->debugNode(0);
+
   while(!this->children.empty())
   {
-    deleteNode = this->children.begin();
-    size = this->children.size();
+    PNode* deleteNode = this->children.front();
+    if (deleteNode == last)
+    {
+      PRINTF(1)("Node same as last that was tried to be deleted. FORCE reparent to NULL of %p\n", deleteNode);
+      (deleteNode->setParent( NULL));
+      continue;
+    }
     if ((this->parentMode & PNODE_PROHIBIT_CHILD_DELETE) ||
-        ((*deleteNode)->parentMode & PNODE_PROHIBIT_DELETE_WITH_PARENT))
+        (deleteNode->parentMode & PNODE_PROHIBIT_DELETE_WITH_PARENT))
     {
-      if (this == PNode::nullParent && (*deleteNode)->parentMode & PNODE_REPARENT_TO_NULL)
+      if (this == PNode::nullParent && deleteNode->parentMode & PNODE_REPARENT_TO_NULL)
       {
         PRINTF(4)("%s::%s deletes %s::%s\n",
                   this->getClassCName(), this->getCName(),
-                  (*deleteNode)->getClassCName(), (*deleteNode)->getCName());
-        delete (*deleteNode);
+                  deleteNode->getClassCName(), deleteNode->getCName());
+        delete deleteNode;
       }
       else
@@ -99,6 +106,6 @@
         PRINTF(4)("%s::%s reparents %s::%s\n",
                   this->getClassCName(), this->getCName(),
-                  (*deleteNode)->getClassCName(), (*deleteNode)->getCName());
-        (*deleteNode)->reparent();
+                  deleteNode->getClassCName(), deleteNode->getCName());
+        deleteNode->reparent();
       }
     }
@@ -107,7 +114,8 @@
       PRINTF(4)("%s::%s deletes PNode: %s::%s\n",
                 this->getClassCName(), this->getCName(),
-                (*deleteNode)->getClassCName(), (*deleteNode)->getCName());
-      delete (*deleteNode);
+                deleteNode->getClassCName(), deleteNode->getCName());
+      delete deleteNode;
     }
+    last = deleteNode;
   }
 
@@ -541,5 +549,5 @@
 void PNode::addChild (const std::string& childName)
 {
-  PNode* childNode = dynamic_cast<PNode*>(ClassList::getObject(childName, CL_PARENT_NODE));
+  PNode* childNode = PNode::objectList().getObject(childName);
   //  PRINTF(0)("Adding the Child: %s to: %s\n", childName, this->getName());
   //  assert( childNode != NULL );
@@ -625,5 +633,5 @@
 void PNode::setParent (const std::string& parentName)
 {
-  PNode* parentNode = dynamic_cast<PNode*>(ClassList::getObject(parentName, CL_PARENT_NODE));
+  PNode* parentNode = PNode::objectList().getObject(parentName);
   if (parentNode != NULL)
     parentNode->addChild(this);
@@ -681,5 +689,5 @@
 void PNode::setParentSoft(const std::string& parentName, float bias)
 {
-  PNode* parentNode = dynamic_cast<PNode*>(ClassList::getObject(parentName, CL_PARENT_NODE));
+  PNode* parentNode = PNode::objectList().getObject(parentName);
   if (parentNode != NULL)
     this->setParentSoft(parentNode, bias);
@@ -730,6 +738,6 @@
   if (likely(PNode::nullParent == NULL))
   {
-    PNode::nullParent = new PNode(NULL, PNODE_PARENT_MODE_DEFAULT | PNODE_REPARENT_TO_NULL);
-    PNode::nullParent->setClassID(CL_NULL_PARENT, "NullParent");
+    PNode::nullParent = new NullParent();
+    //PNode::nullParent->registerObject(, CL_NULL_PARENT);
     PNode::nullParent->setName("NullParent");
     PNode::nullParent->setSynchronized(true);
@@ -915,5 +923,5 @@
   int childNodeCount = 0;
   this->countChildNodes(childNodeCount);
-
+  printf("%p:", this);
   PRINT(0)("PNode(%s::%s) - absCoord: (%0.2f, %0.2f, %0.2f), relCoord(%0.2f, %0.2f, %0.2f), direction(%0.2f, %0.2f, %0.2f) - %s - %d childs\n",
            this->getClassCName(),
@@ -1106,3 +1114,9 @@
 }
 
-
+ObjectListDefinition(NullParent);
+
+NullParent::NullParent()
+  : PNode(NULL, PNODE_PARENT_MODE_DEFAULT | PNODE_REPARENT_TO_NULL)
+{
+  this->registerObject(this, NullParent::_objectList);
+}
Index: trunk/src/lib/coord/p_node.h
===================================================================
--- trunk/src/lib/coord/p_node.h	(revision 9682)
+++ trunk/src/lib/coord/p_node.h	(revision 9869)
@@ -50,5 +50,5 @@
   PNODE_REPARENT_DELETE_CHILDREN       = 0x0040,    //!< Deletes the Children of the node when This Node is Removed. (Use with care).
   /// FIXME
-   PNODE_REPARENT_KEEP_POSITION         = 0x0080,    //!< Tries to keep the Position if the Node is reparented.
+  PNODE_REPARENT_KEEP_POSITION         = 0x0080,    //!< Tries to keep the Position if the Node is reparented.
 
 
@@ -73,6 +73,9 @@
 
 //! Patent Node is a Engine to calculate the position of an Object in respect to the position of its parent.
-class PNode : virtual public BaseObject, virtual public Synchronizeable {
- public:
+class PNode : virtual public BaseObject, virtual public Synchronizeable
+{
+  ObjectListDeclaration(PNode);
+
+public:
   PNode (PNode* parent = PNode::getNullParent(), long nodeFlags = PNODE_PARENT_MODE_DEFAULT);
   virtual ~PNode ();
@@ -95,5 +98,5 @@
   inline const Vector& getRelCoor () const { return this->prevRelCoordinate; };
   /** @returns the Relative Coordinate Destination */
-  inline const Vector& getRelCoorSoft2D() const { return (this->toCoordinate)? *this->toCoordinate : this->relCoordinate; };
+inline const Vector& getRelCoorSoft2D() const { return (this->toCoordinate)? *this->toCoordinate : this->relCoordinate; };
   void setAbsCoor (const Vector& absCoord);
   void setAbsCoor (float x, float y, float z);
@@ -130,5 +133,5 @@
   inline const Quaternion& getRelDir () const { return this->prevRelDirection; };
   /** @returns the Relative Directional Destination */
-  inline const Quaternion& getRelDirSoft2D() const { return (this->toDirection)? *this->toDirection : this->relDirection; };
+inline const Quaternion& getRelDirSoft2D() const { return (this->toDirection)? *this->toDirection : this->relDirection; };
   /** @returns a Vector pointing into the relative Direction */
   inline Vector getRelDirV() const { return this->prevRelDirection.apply(Vector(0,1,0)); };
@@ -178,7 +181,6 @@
   void removeNodeFlags(unsigned short nodeFlags);
 
-  // NULL_PARENT //
   /** @returns the NullParent, the (main) ROOT of the PNode Tree. If it does not yet exist, it will be created. */
-  static PNode* getNullParent()  { return (PNode::nullParent != NULL)? PNode::nullParent : PNode::createNullParent(); };
+static PNode* getNullParent()  { return (PNode::nullParent != NULL) ? PNode::nullParent : PNode::createNullParent(); };
 
   // UPDATING //
@@ -195,13 +197,13 @@
   float distance(const PNode* node) const { return (this->getAbsCoor() - node->getAbsCoor()).len(); };
 
- private:
+private:
   /** tells the child that the parent's Coordinate has changed */
   inline void parentCoorChanged () { this->bRelCoorChanged = true; }
   /** tells the child that the parent's Direction has changed */
   inline void parentDirChanged () { this->bRelDirChanged = true; }
- public:
+public:
   /** @returns the last calculated coordinate */
   inline Vector getLastAbsCoor() { return this->lastAbsCoordinate; }
- private:
+private:
   static PNode* createNullParent();
   void reparent();
@@ -209,5 +211,5 @@
   void eraseChild(PNode* child);
 
- private:
+private:
   bool               bRelCoorChanged;    //!< If Relative Coordinate has changed since last time we checked
   bool               bRelDirChanged;     //!< If Relative Direction has changed since last time we checked
@@ -221,5 +223,5 @@
   Vector             lastAbsCoordinate;  //!< this is used for speedcalculation, it stores the last coordinate
   Quaternion         prevRelDirection;   //!< The last Relative Direciton from the last update-Cycle.
-//  Quaternion         lastAbsDirection;
+  //  Quaternion         lastAbsDirection;
 
   Vector             velocity;           //!< Saves the velocity.
@@ -238,23 +240,32 @@
   static PNode*      nullParent;         //!< The ROOT of the main PNode Tree.
 
-  private:
-    float coorx;
-    float coory;
-    float coorz;
-
-    float rotw;
-    float rotx;
-    float roty;
-    float rotz;
-
-  private:
-    int relCoordinate_handle;
-    int relDirection_handle;
-    Vector relCoordinate_write;
-    Quaternion relDirection_write;
-
-  public:
-    virtual void varChangeHandler( std::list<int> & id );
+private:
+  float coorx;
+  float coory;
+  float coorz;
+
+  float rotw;
+  float rotx;
+  float roty;
+  float rotz;
+
+private:
+  int relCoordinate_handle;
+  int relDirection_handle;
+  Vector relCoordinate_write;
+  Quaternion relDirection_write;
+
+public:
+  virtual void varChangeHandler( std::list<int> & id );
 };
 
+// NULL_PARENT //
+class NullParent : public PNode
+{
+  ObjectListDeclaration(NullParent);
+  friend class PNode;
+  NullParent();
+};
+
+
 #endif /* _P_NODE_H */
